﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;

// Open the Add References dialog. On the COM tab, select
// "Microsoft Excel 14.0 Object Library" (or whatever
// version you have installed on your system).

using Excel = Microsoft.Office.Interop.Excel;

namespace howto_transfer_excel_data
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            txtFromFile.Text = Path.Combine(
                Application.StartupPath,
                "Book1.xlsx");
            txtToFile.Text = Path.Combine(
                Application.StartupPath,
                "Book2.xlsx");
        }

        private void btnCopy_Click(object sender, EventArgs e)
        {
            // Get the Excel application object.
            Excel.Application excel_app = new Excel.ApplicationClass();

            // Make Excel visible (optional).
            //excel_app.Visible = true;

            // Open the from workbook read-only.
            Excel.Workbook from_workbook = excel_app.Workbooks.Open(
                txtFromFile.Text,
                Type.Missing, true, Type.Missing, Type.Missing,
                Type.Missing, Type.Missing, Type.Missing, Type.Missing,
                Type.Missing, Type.Missing, Type.Missing, Type.Missing,
                Type.Missing, Type.Missing);

            // Get the first worksheet.
            Excel.Worksheet from_sheet = (Excel.Worksheet)from_workbook.Sheets[1];

            // Get the from range.
            string from_cell1 = txtFromRange.Text.Split(':')[0];
            string from_cell2 = txtFromRange.Text.Split(':')[1];
            Excel.Range from_range = from_sheet.get_Range(from_cell1, from_cell2);

            // Open the to workbook read-write.
            Excel.Workbook to_workbook = excel_app.Workbooks.Open(
                txtToFile.Text,
                Type.Missing, false, Type.Missing, Type.Missing,
                Type.Missing, Type.Missing, Type.Missing, Type.Missing,
                Type.Missing, Type.Missing, Type.Missing, Type.Missing,
                Type.Missing, Type.Missing);

            // Get the first worksheet.
            Excel.Worksheet to_sheet = (Excel.Worksheet)to_workbook.Sheets[1];

            // Get the to range.
            string to_cell1 = txtToRange.Text.Split(':')[0];
            string to_cell2 = txtToRange.Text.Split(':')[1];
            Excel.Range to_range = to_sheet.get_Range(to_cell1, to_cell2);

            // Copy the data.
            to_range.Value2 = from_range.Value2;

            // Close the from workbook without saving changes.
            from_workbook.Close(false, Type.Missing, Type.Missing);

            // Close the to workbook while saving changes.
            to_workbook.Close(true, Type.Missing, Type.Missing);

            // Close the Excel server.
            excel_app.Quit();

            MessageBox.Show("Done");
        }
    }
}
